# main.py
# -*- coding: utf-8 -*-
# cython: language_level=3
from 预定系统.base.Mqtt_Android import Mqtt
from datetime import datetime
import logging
import time

if __name__ == "__main__":
    # 读取配置文件
    configs = Mqtt.read_config_from_csv('../测试数据/MQTT上报数据.csv')

    broker_address = "192.168.5.218"
    port = 1883
    topic = "rebootResponseTopic"
    num_repeats = 100  # 重复执行的次数
    interval_between_repeats = 0.5  # 每次重复之间的间隔时间（秒）

    # 创建 MQTT 客户端实例
    mqtt_client = Mqtt(broker_address, port)

    try:
        # 连接到 MQTT 服务器
        mqtt_client.connect()

        for repeat in range(num_repeats):
            logging.info(f"开始第 {repeat + 1} 次上报")

            # 遍历配置文件中的每一行数据
            for config in configs:
                # 构建消息内容
                current_time = datetime.now().strftime("%Y-%m-%d %H:%M:%S")
                message = Mqtt.build_message(config, current_time)

                # 发送消息
                mqtt_client.publish(topic, message)

                # 每次发送之间可以设置一个间隔时间
                time.sleep(0.2)

            # 每次重复之间设置一个间隔时间
            time.sleep(interval_between_repeats)

    except Exception as e:
        logging.error(f"发送消息时发生错误: {e}")

    finally:
        # 断开与 MQTT 服务器的连接
        mqtt_client.disconnect()
